#include <windows.h>
#include <string>
#ifdef _WIN32_WCE
	#include <Pmpolicy.h>
	#include <pm.h>
#endif

#ifdef _WIN32_WCE
BOOL stop_power_notification(HANDLE h)
{
	return StopPowerNotifications(h);
}
#endif


template < BOOL (__stdcall*T)( HANDLE ), HANDLE BAD_HANDLE = INVALID_HANDLE_VALUE >
class SysHandle
{
private:
	HANDLE handle;

public:
	SysHandle( HANDLE handle ) :
	  handle( handle )
	  {}
	  ~SysHandle()
	  {
		  if ( handle != BAD_HANDLE )
			  (*T)( handle );
	  }
	  const HANDLE& get_handle()const
	  {
		  return handle;
	  }
};

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
					 #ifdef _WIN32_WCE
						LPTSTR    lpCmdLine,
					 #else
					    LPSTR    lpCmdLine,
					 #endif
                     int       nCmdShow)
{
#ifdef _WIN32_WCE
	MSGQUEUEOPTIONS msgOptions = {0};   
	msgOptions.dwSize = sizeof(MSGQUEUEOPTIONS);
	msgOptions.dwFlags = 0;
	msgOptions.dwMaxMessages = 10;
	msgOptions.cbMaxMessage = sizeof(POWER_BROADCAST) + MAX_PATH;
	msgOptions.bReadAccess = TRUE;

	SysHandle<CloseMsgQueue> m_hQueue( ::CreateMsgQueue(L"fireworks", &msgOptions) );
	if (! m_hQueue.get_handle() )
	{
		return 0;
	}

	SysHandle<stop_power_notification> h_Not( ::RequestPowerNotifications(m_hQueue.get_handle(), POWER_NOTIFY_ALL) );
	if (! h_Not.get_handle() )
	{
		return 0;
	}

	PowerPolicyNotify(PPN_UNATTENDEDMODE, TRUE);  // Unlocked - go to unattended mode
	while(true)
	{
		DWORD dwReaded = 0;
		DWORD dwFlags = 0;
		unsigned char buffer[sizeof(POWER_BROADCAST) + MAX_PATH*2];
		if (::ReadMsgQueue(m_hQueue.get_handle(), buffer, sizeof(buffer), &dwReaded, 1000, &dwFlags)) 
		{
			if (dwReaded>=sizeof(POWER_BROADCAST)) 
			{
				const POWER_BROADCAST * pb = reinterpret_cast<const POWER_BROADCAST *>(buffer);
				if( pb->Flags & POWER_STATE_UNATTENDED )
				{
					SHELLEXECUTEINFO sei;
					memset(&sei,0x00,sizeof(SHELLEXECUTEINFO));
					sei.cbSize=sizeof(SHELLEXECUTEINFO);
					std::wstring filepath = L"\\Temp\\firework.exe";
					sei.lpFile= filepath.c_str();
					sei.hwnd=NULL;
					sei.lpVerb=L"open";

					sei.lpParameters = NULL;

					sei.lpDirectory=NULL;
					sei.nShow=SW_SHOWNORMAL;
					sei.lpClass = NULL;
					sei.fMask=SEE_MASK_NOCLOSEPROCESS;
					ShellExecuteEx(&sei);
				}
			}
		}
	}
#endif

	return 0;
}